#include "sprite.h"

// RXgN^
Sprite::Sprite()
{
	pos.x = pos.y = 0.0f;
	width = 0;
	height = 0;
	divU = 1;
	divV = 1;
	numU = 0;
	numV = 0;
	rotate = 0.0f;
}
// fXgN^
Sprite::~Sprite(){}

void Sprite::SetPos(float x,float y)
{
	pos.x = x;
	pos.y = y;
}
void Sprite::SetWidth(int Width,int Height)
{
	width = Width;
	height = Height;
}

void Sprite::SetRotate(float Rotate)
{
	rotate = Rotate;
}

void Sprite::SetDivide(unsigned int DivU,unsigned int DivV)
{
	if(DivU <= 0 || DivV <= 0)
		return;

	divU = DivU;
	divV = DivV;
}

void Sprite::SetUVNum(unsigned int NumU,unsigned int NumV)
{
	if(NumU >= divU)
		return;
	if(NumV >= divV)
		return;

	numU = NumU;
	numV = NumV;
}

void Sprite::Draw(IDirect3DDevice9* pDevice3D,IDirect3DTexture9* pTexture,bool isTurn)
{
	// _Zbg
	Vertex vtx[4]={
		{ (float) width/2,(float)-height/2, 0.0f, 1.0f,(isTurn ? (float)numU/divU : (float)(numU + 1)/divU), (float)numV/divV},
		{ (float) width/2,(float) height/2, 0.0f, 1.0f,(isTurn ? (float)numU/divU : (float)(numU + 1)/divU), (float)(numV + 1)/divV}, 
		{ (float)-width/2,(float)-height/2, 0.0f, 1.0f,(isTurn ? (float)(numU + 1)/divU : (float)numU/divU), (float)numV/divV}, 
		{ (float)-width/2,(float) height/2, 0.0f, 1.0f,(isTurn ? (float)(numU + 1)/divU : (float)numU/divU), (float)(numV + 1)/divV} 
	};

	for(int i = 0;i < 4;++i){
		float x = vtx[i].x * cosf(rotate) - vtx[i].y * sinf(rotate);
		float y = vtx[i].x * sinf(rotate) + vtx[i].y * cosf(rotate);
		vtx[i].x = x + pos.x;
		vtx[i].y = y + pos.y;
	}
	// eNX`Zbg
	pDevice3D->SetTexture(0,pTexture);
	// _\̐錾Zbg
	pDevice3D->SetFVF(SPRITE_FVF);
	// XvCg`
	pDevice3D->DrawPrimitiveUP(D3DPT_TRIANGLESTRIP,2,vtx,sizeof(Vertex));
}